-- Gene from Lagrange Point™ was here

rawset(_G, "CONFIG_Queue", CONFIG_Queue or {})

local function CONFIG_RegisterVar(var)
	table.insert(CONFIG_Queue, var)
	return CV_RegisterVar(var)
end

//[NITRO 2.2.18] (visuals?????)

local k_position = k_position // blua is, it literally just is. shit's on a league of its own
local MAXSKINSVANILLA = 101 // MAXSKINCOLORS in kart 1.5; put here so custom clients don't get angry
local FRACUNIT = FRACUNIT
local TICRATE = TICRATE
local starttime = 6*TICRATE + (3*TICRATE/4)

local boostEQTable = {62356, 58632, 55053, 51605, 48285, 45081, 41990, 39007, 32768}
-- formulas weren't cutting it, so a table of extremely close estimates was made

local dmodDebug = false
if dmodDebug then print("NITRO DEBUG MODE ON. GAMEPLAY INTENDED FOR MECHANIC TESTING.") end

local customPrompt = {"Custom 1", "Custom 2", "Custom 3"}

local infoSt1 =
"\137DRIFTNITRO, version 2.3 by Azur and Froge\128\
Fill your \135orange meter\128 by drifting to get boost items!\
Your \132blue meter\128 will fill over time."

local infoSt2 =
"Once full, any Nitros you have will \136turn blue,\128 giving you a stronger, longer boost!\
By the way, you can hit \130Custom 3 (or your set custom button)\128 to swap placements of your Nitros.\
(This message will only appear once.)"

freeslot("sfx_ntrsw", "sfx_ntrsw2", "sfx_ntrble")

local dmodsparkcolors = {
    SKINCOLOR_SAPPHIRE,
    SKINCOLOR_KETCHUP,
    "rainbow"
}

local boostInheritance = {
	18, // 1
	16, // 2
	14, // 3
	12, // 4
	10, // 5
	8, // 6
	6, // 7
	4, // 8
	2  // 9
}

rawset(_G, "driftmodData", {
	isOn = false,
	meterRate = 100, // just how many times have we done this change
	yelRate = 70,
	yelDecay = 3,
	boostRate = 67, // boost rates are a percentage bonus, default 90%
	boostPercent = 90,
	slipstreamRate = 15,
	bonusDiv = 4,
	specialMtrSize = 100000,
	exMeterSize = 300,
	exBoostRate = 300,
	hyuuFactor = 25,
	sliptideFactor = 166,
})

local extraPoints = {200, 400, 600}

addHook("NetVars", function(n)
	driftmodData = n($) // let's see how a netvar fares
end)

local function getFloatString(n)
	return string.format("%d.%02d", n/100, n%100)
end

local cv_driftmod = CV_RegisterVar({
	name = "driftnitro",
	defaultvalue = "On",
	flags = CV_NETVAR,
	possiblevalue = CV_OnOff,
})

COM_AddCommand("dfm_setcustomtype", function(player, n)
	if not (gamestate == GS_LEVEL or gamestate == GS_INTERMISSION or gamestate == GS_VOTING) then
		CONS_Printf(player, "You must be in a level to use this.")
		return
	end
	n = tonumber(n)
	if not n or n < 1 or n > 3 then
		CONS_Printf(player, "Please specify a value between 1 and 3.")
		CONS_Printf(player, "\130There are only 3 custom buttons. The number you put in will set your special item button to the corresponding custom button.")
	else
		if n == 1 then
			player.specialBtMem = BT_CUSTOM1
		elseif n == 2 then
			player.specialBtMem = BT_CUSTOM2
		elseif n == 3 then
			player.specialBtMem = BT_CUSTOM3
		end
		player.cusPref = n
		CONS_Printf(player, "Your special item button will be Custom "..n.." next round.")
	end
end)

local cv_swapsound = CONFIG_RegisterVar{
	name = "driftnitro_swapsound",
	defaultvalue = "Whooshes",
	possiblevalue = { Whooshes = 0, Ticks = 1 },

	config_menu = "HUD",
	displayname = "DriftNitro swap sound",
	description = "Change the sound for swapping boosts."
}

local cv_boosthud = CONFIG_RegisterVar{
	name = "driftnitro_boosthud",
	defaultvalue = "HUD",
	possiblevalue = { HUD = 0, Follow = 1 },

	config_menu = "HUD",
	displayname = "DriftNitro HUD",
	description = "Change how the stack count and boost timer are displayed."
}

local cv_blueon = CV_RegisterVar({
	name = "dn_blueon",
	defaultvalue = "On",
	flags = CV_NETVAR,
	possiblevalue = CV_OnOff,
})

-- this doesn't actually turn off the EX meter lol, just hides it
local cv_exbonus = CV_RegisterVar({
	name = "dn_exbonus",
	defaultvalue = "On",
	flags = CV_NETVAR,
	possiblevalue = CV_OnOff,
})

COM_AddCommand("dfm_setbluelength", function(player, num)
	local exfrac = getFloatString(driftmodData.specialMtrSize/10)
	if num == nil then
		CONS_Printf(player, "The blue meter length is "..exfrac.."%.\n")
		return
	end
	local fracced = floatToFrac(num)
	if fracced <= 0 then
		CONS_Printf(player, "Please specify a value greater than 0.")
	elseif fracced > 20000 then
		CONS_Printf(player, "Please specify a value less than or equal to 200.")
	else
		driftmodData.specialMtrSize = fracced*10
		CONS_Printf(player, "The blue meter length is now "..num.."%.\n".."\x82".."NOTE: The final length is the value you put in times 10.")
		CONS_Printf(player, "\x82".."Default value: 100")
	end
end, COM_ADMIN)

COM_AddCommand("dfm_setexboost", function(player, num)
	local exfrac = getFloatString(driftmodData.exBoostRate*10)
	if num == nil then
		CONS_Printf(player, "The EX boost rate is "..exfrac.."%.\n")
		return
	end
	local fracced = floatToFrac(num)
	if fracced <= 0
		CONS_Printf(player, "Please specify a value greater than 0.")
	elseif fracced > 20000 then
		CONS_Printf(player, "Please specify a value less than or equal to 200.")
	else
		driftmodData.exBoostRate = fracced/10
		CONS_Printf(player, "The EX boost rate is now "..num.."%.\n")
		CONS_Printf(player, "\x82".."Default value: 30.00%")
	end
end, COM_ADMIN)

COM_AddCommand("dfm_setexlength", function(player, num)
	local exfrac = getFloatString(driftmodData.exMeterSize*10)
	if num == nil then
		CONS_Printf(player, "The EX meter length is "..exfrac.."%.\n")
		return
	end
	local fracced = floatToFrac(num)
	if fracced < 100 then
		CONS_Printf(player, "Please specify a value greater than, or equaling 1.")
	elseif fracced > 20000 then
		CONS_Printf(player, "Please specify a value less than or equal to 200.")
	else
		driftmodData.exMeterSize = fracced/10
		CONS_Printf(player, "The EX meter length is now "..num.."%.\n")
		CONS_Printf(player, "\x82".."Default value: 50.00%")
	end
end, COM_ADMIN)

// rate adjust custvars

COM_AddCommand("dfm_setexrate", function(player, num)
	local exfrac = getFloatString(driftmodData.yelRate)
	if num == nil then
		CONS_Printf(player, "The EX meter rate is "..exfrac.."%.\n")
		return
	end
	local fracced = floatToFrac(num)
	if fracced <= 0 then
		CONS_Printf(player, "Please specify a value greater than 0.")
	elseif fracced > 1200 then
		CONS_Printf(player, "Please specify a value less than or equal to 12.")
	else
		driftmodData.yelRate = fracced
		CONS_Printf(player, "The EX meter rate is now "..num.."% every 5 seconds.\n")
		CONS_Printf(player, "\x82".."Default value: 0.7%")
	end
end, COM_ADMIN)

COM_AddCommand("dfm_setmeterrate", function(player, num)
	local exfrac = getFloatString(driftmodData.meterRate)
	if num == nil then
		CONS_Printf(player, "The orange meter rate is "..exfrac.."%.\n")
		return
	end
	local n = tonumber(num)
	local fracced = floatToFrac(num)
	if fracced <= 0 then
		CONS_Printf(player, "Please specify a value greater than 0.")
	elseif fracced > 9999 then
		CONS_Printf(player, "Please specify a value less than or equal to 99.99.")
	else
		driftmodData.meterRate = fracced
		driftmodData.boostRate = (fracced * driftmodData.boostPercent) / 100 // readjust boost rate by percentage
		CONS_Printf(player, "The ".."\x87".."orange meter rate ".."\x80".."is now "..num.."%.\n".."\x82".."NOTE: The default value is 1.00%.")
	end
end, COM_ADMIN)

COM_AddCommand("dfm_setboostpct", function(player, num)
	local exfrac = getFloatString(driftmodData.boostPercent*100)
	if num == nil then
		CONS_Printf(player, "The boost bonus percentage is "..exfrac.."%.\n")
		return
	end
	local n = tonumber(num)
	if n <= 0 then
		CONS_Printf(player, "Please specify a percentage greater than 0%.")
	elseif n > 100 then
		CONS_Printf(player, "Please specify a value less than or equal to 100%.")
	else
		driftmodData.boostPercent = n
		driftmodData.boostRate = ( (driftmodData.meterRate * (driftmodData.boostPercent)) / 100) // readjust boost rate by percentage
		CONS_Printf(player, "The ".."\x83".."boost bonus percentage ".."\x80".."is now "..num.."%.\n".."\x82".."NOTE: The default value is 90%.")
	end
end, COM_ADMIN)

COM_AddCommand("dfm_setexdecay", function(player, num)
	local decayfrac = getFloatString(driftmodData.yelDecay)
	if num == nil then
		CONS_Printf(player, "The EX meter decay rate is "..decayfrac.."%\n")
		return
	end

	local fracced = floatToFrac(num)
	if fracced <= 1 then
		CONS_Printf(player, "Please specify a value greater than 0.01.")
	elseif fracced > 10000 then
		CONS_Printf(player, "Please specify a value less than or equal to 100.")
	else
		driftmodData.yelDecay = fracced
		CONS_Printf(player, "The EX meter decay rate is now "..num.."%\n")
		CONS_Printf(player, "\x82".."Default value: 0.03%")
	end
end, COM_ADMIN)

COM_AddCommand("dfm_setbonusdiv", function(player, num)
	local decayfrac = driftmodData.bonusDiv
	if num == nil then
		CONS_Printf(player, "The bonus division is "..decayfrac.."\n")
		return
	end
	local n = tonumber(num)
	if n <= 0 then
		CONS_Printf(player, "Please specify a value greater than or equal to 2.")
	elseif n > 10
		CONS_Printf(player, "Please specify a value less than or equal to 10.")
	else
		driftmodData.bonusDiv = n
		CONS_Printf(player, "The bonus division is now "..num..".\n".."\x82".."NOTE: The default value is 4.")
	end
end, COM_ADMIN)

COM_AddCommand("dfm_setslipfactor", function(player, num)
	local decayfrac = floatToFrac(driftmodData.sliptideFactor)
	if num == nil then
		CONS_Printf(player, "The Sliptide factor is "..decayfrac.."%\n")
		return
	end
	local fracced = floatToFrac(num)
	if fracced <= 0 then
		CONS_Printf(player, "Please specify a value greater than 0.")
	elseif fracced > 200 then
		CONS_Printf(player, "Please specify a (decimal) value less than or equal to 2.")
	else
		CONS_Printf(player, "The Sliptide factor is now "..num..".\n".."\x82".."NOTE: The default value is 1.66%.")
		driftmodData.sliptideFactor = fracced
	end
end, COM_ADMIN)

// slipstream crossmod
COM_AddCommand("dfm_setssrate", function(player, num)
	local cv_slipstream = CV_FindVar("slipstream_enabled") or CV_FindVar("ss_enabled")
	if cv_slipstream == nil then //  you don't even have slipstream
		CONS_Printf(player, "You need Ashnal's Kart Slipstream/Drafting to use this command!\n")
		return
	end

	local decayFrac = floatToFrac(driftmodData.slipstreamRate)
	if num == nil then
		CONS_Printf(player, "The slipstream bonus rate is "..decayfrac.."%\n")
		return
	end
	local fracced = floatToFrac(num)
	if fracced <= 0 then
		CONS_Printf(player, "Please specify a value greater than 0.")
	elseif fracced > 9999 then
		CONS_Printf(player, "Please specify a value less than or equal to 99.99.")
	else
		driftmodData.slipstreamRate = fracced
		CONS_Printf(player, "The ".."\x82".."slipstream bonus rate ".."\x80".."is now "..num.."%.\n".."\x82".."NOTE: The default value is 0.15%.")
	end
end, COM_ADMIN)

COM_AddCommand("dfm_getinfo", function()
	if CV_FindVar("dfm_bumpcode") and CV_FindVar("dfm_bumpcode").value then
		print("\x83".."NOTICE: DriftNitro's custom bumpcode is being used.\n".."\x80")
	end

	local floatedOrange = getFloatString(driftmodData.meterRate)
	print("\x87".."Orange meter rate: ".."\x80"..floatedOrange.."% ".."\x82".." (Default rate: 1.00%)")

	local meterSize = (((driftmodData.specialMtrSize)/1000).." * 10 = "..((driftmodData.specialMtrSize)/100))
	if cv_blueon.value then
		print("\x84".."Blue meter: ".."\x83".."ON".."\x80")
		print("\x84".."Blue meter length: ".."\x80"..meterSize.."\n")
	else
		print("\x84".."Blue meter: ".."\x85".."OFF".."\x80".."\n")
	end

	local floatedYellow = getFloatString(driftmodData.exMeterSize*10)
	if cv_exbonus.value then
		print("\x82".."EX-Bonus: ".."\x83".."ON".."\x80")
		print("\x82".."Maximum EX percentage: ".."\x80"..floatedYellow.."% (Default: 30.00%)")
		print("\x82".."EX Meter rate: ".."\x80"..getFloatString(driftmodData.yelRate).." (Increase), "..getFloatString(driftmodData.yelDecay*10).." (Decay)")
		print("\x82".."(Defaults: 0.70% [Inc], 0.30% [Dec])")
		print("\x82".."EX Boost power: ".."\x80"..getFloatString(driftmodData.exBoostRate*10).."% (Default: 30.00%)".."\n")
	else
		print("\x82".."EX-Bonus: ".."\x85".."OFF".."\x80".."\n")
	end

	local boostfactor = getFloatString(driftmodData.boostRate)
	print("Boost bonus factor: "..boostfactor.." ("..driftmodData.boostPercent.."% orange rate, ".."\x82".."default rate: 90%".."\x80"..")")
	print("\130Boost bonuses only occur during drifts.")
	print("\130Drifting at above 110% speed will also activate the boost bonus.\n")

	local cv_slipstream = CV_FindVar("slipstream_enabled") or CV_FindVar("ss_enabled") // future proofing the latest beta, this prefix is interchangeable
	local slip = getFloatString(driftmodData.sliptideFactor)
	print("Sliptide factor: "..slip.."\x82".." (Default factor: 1.66) \nNOTE: The orange rate is multiplied by this value for sliptiding.\n")
	if cv_slipstream and cv_slipstream.value then
		local ss = getFloatString(driftmodData.slipstreamRate)
		print("Slipstream bonus factor: "..ss.."\x82".." (Default rate: 0.15) \n")
	end

	local bonusfactor = getFloatString(100 / driftmodData.bonusDiv)
	print("Bonus factor: "..bonusfactor)
	print("\x82".."Orange bonus metric: ".."\x87".."Orange rate ".."\x82".."x Position x Distance".."\x80")
	if cv_blueon.value then print("\x82".."Blue bonus metric: ".."\x84".."Blue rate ".."\x82".."x (Position x 13)".."\x80") end
end, COM_LOCAL)

local function K_GetDriftFactor(p)
	local driftadditive = 0

	if (p.kartstuff[k_drift] >= 1) // Drifting to the left
		if (p.cmd.driftturn > 0) // Inward
			driftadditive = ($ + abs(p.cmd.driftturn)/66) // 0.15
		end

		if (p.cmd.driftturn < 0) // Outward
			driftadditive = ($ - abs(p.cmd.driftturn)/100) // 0.1
		end
	elseif (p.kartstuff[k_drift] <= -1) // Drifting to the right
		if (p.cmd.driftturn < 0) // Inward
			driftadditive = ($ + abs(p.cmd.driftturn)/66)
		end

		if (p.cmd.driftturn > 0) // Outward
			driftadditive = ($ - abs(p.cmd.driftturn)/100)
		end
	end

	return driftadditive
end

local function K_GetSneakerSpeed()
	local speedboost = 32768

	local cv_hardsneak = CV_FindVar("kmp_hardsneakers")

	if (gamespeed == 0)
		speedboost = 53740+768
	elseif (gamespeed == 2)
		speedboost = 17294+768

		if (cv_hardsneak and cv_hardsneak.value)
			speedboost = 32768
		end
	end

	return speedboost
end

local function getDriftLevel(p)
    local charge = p.kartstuff[k_driftcharge]
    local pdv = K_GetKartDriftSparkValue(p)

    if charge >= pdv*4
		return 3
	elseif charge >= pdv*2
        return 2
	elseif charge >= pdv
		return 1
    else
		return 0
	end
end

local function getPlayercount()
	local g = 0
	for p in players.iterate do
		if not p.spectator then
			g = $ + 1
		end
	end
	return g
end

local function getPixelSine(k, ang)
	return (k*sin(ang)) / FRACUNIT
end

local function getPixelCosine(k, ang)
	return (k*cos(ang)) / FRACUNIT
end

local function dfn_checkForEmptySlots(p, size)
	for i = 1, size
		if (p.driftmod.nitroItems[i] == 0) then return i end
	end
	return -1
end

local function dfn_findFullSlots(p)
	for i = 1, 2
		if (p.driftmod.nitroItems[i] ~= 0) then return i end
	end
	return -1
end

local function dmod_giveRewardSneaker(p, pity)
	-- will this situation actually occur? only one way to find out
	if leveltime <= 230 then S_StartSound(nil, sfx_ambint); return end

	local threeCheck = p.driftmod.hasThirdNitro and 3 or 2

	local firstEmpty = dfn_checkForEmptySlots(p, p.driftmod.hasFourthNitro and 4 or threeCheck)
	if firstEmpty ~= -1 then
		if pity then
			p.driftmod.nitroItems[firstEmpty] = 2
			S_StartSound(nil, sfx_itroln or sfx_itrolm, p) -- neoroulette
		else
			p.driftmod.nitroItems[firstEmpty] = 1
			S_StartSound(nil, sfx_itrolf, p)
		end
	end
end

local function getBonusExponential(a, b)
	local bDiv = b > 0 and 15 - (b - 1) or 1
	return 200 - ((150 - a^2 * (a^2/3))/bDiv)
end

local function getBonusValue(p)
	local finalBonus = 0
    local pPos = p.kartstuff[k_position]
	local pcnt = getPlayercount()
    local divto15 = ((pcnt * 100) /15)
    local g = (pPos*10000/divto15)
    local divFactor = (15-((g/100)-2))
    local finalDiv = ((divFactor <= 15) and divFactor or 15)

	finalBonus = getBonusExponential(pPos, finalDiv)

	if ((pcnt == 1) or (pPos == 1)) then finalBonus = 0 end
    return finalBonus
end

// anything that lets you use sneakers mid-air bugs out the system, so I'm shoving them into a function
local function dMod_PlayerInCourseGimmick(p)
	if p.grinding
	or p.mo.paragliding
	or p.nitroGimmickFlag // futureproof I hope
		return true
	end

	return false
end

local function getBoostScale(p, doBlue) // true scaling is dead, time for universal speeds :^)
    local defaultTime = 45 //TICRATE + (TICRATE/3)
    local blueTime = 105 // (TICRATE*3)
	return doBlue and blueTime or defaultTime
end

local function getKartPercent(p)
	local origFriction = 62914
	return (FixedDiv(p.speed, FixedMul(K_GetKartSpeed(p, false), origFriction))*100)>>FRACBITS
end

/*9 speed = 61
1 speed = 57

4 fracunit difference

boostpower (unless offroad) is ALWAYS 1 fracunit

in normal speed, your kart boosts at about 1<<15 units (32768 units), or 1/2 a frac

to get the results (for 1 speed) we need to make it so that your speedboost equals 3*/

// nitro consumption handler, making this a rawset for course gimmick futureproofing
rawset(_G, "consumeNitro", function(p)
	if (p.driftmod.justusednitro) then return end -- abort if you just used a nitro

	if (p.driftmod.nitroItems[1] == 2)
		p.driftmod.nitroBoostType = 2
	end
	
	for i = 1, 3 do
		p.driftmod.nitroItems[i] = p.driftmod.nitroItems[i+1]
		p.driftmod.transformTimer[i] = p.driftmod.transformTimer[i+1]
	end
	p.driftmod.nitroItems[4] = 0
	p.driftmod.transformTimer[4] = 0

	p.driftmod.justusednitro = 6
end)

local function theWholeNineYards(p, blue) // slipstream v4 hacks, and general stuff that'd clutter the main loop
	p.driftmod.nitroBoostCooldown = TICRATE/2

	if (p.driftmod.transformTimer[1]) // auto-cancel transform
		S_StartSound(p.mo, sfx_s25f)
		p.driftmod.blueBoostFlag = true
		p.driftmod.blueBoosting = 3
		if (not p.driftmod.nitroBoostType) then p.driftmod.nitroBoostType = 2 end
		p.driftmod.transformBoost = true
	end

	local boost = getBoostScale(p, blue)

	p.driftmod.potentialblue = boost
	p.driftmod.blueAddDelay = boost
end

local METERFLASHTIME = TICRATE/4

local function runDriftMod(p)
    if leveltime == 0 then return end

    -- Commented out for sunflowers garden. We don't run acrobaTics anyway and
    -- looking up for cvar every frame is costly and i don't really want to redo
    -- that properly atm.
	local cv_acro = nil --CV_FindVar("ac_active")

	local dm = p.driftmod

	if not dm then
		dm = {}
        dm.driftPoints = 0
		dm.previousDriftPoints = 0
		dm.pctSpeedMem = 0
		dm.crashAdd = 0
		dm.crashSub = 0
		dm.gaugeCheat = 0

		--item stuff start
		dm.specialitemtype = 0
		dm.nitroItems = {0, 0, 0, 0} // 1 is normal, 2 is blue
		dm.transformTimer = {0, 0, 0, 0} // for transformation into blue nitro
		dm.blueBlink = {0, 0, 0, 0}
		dm.blueBoosting = 0 // value for the funny custom slipstream
		dm.swapdir = 0
		dm.ntAtkDown = 0
		dm.hasThirdNitro = false
		dm.hasFourthNitro = false
		dm.nitroBoostCooldown = 0
		--item stuff end

		dm.exBarFactor = 0
		dm.exPower = 0
		dm.doRespawnPity = 0
		dm.respawnboost = 0
		dm.crashCooldown = 0
		dm.spinoutPity = false
		dm.blueBoost = false
		dm.blueDriftBoost = false
		dm.specialDriftPoints = 0
		dm.meterFlashTics = 0
		dm.nitroTimeBoosting = 0
		dm.blueAddDelay = 0
		dm.specialBonusAmt = 0 // for blue bar easing
		dm.lastDriftLevel = 0
		dm.meterFactor = driftmodData.meterRate
		dm.boostExtFactor = driftmodData.boostRate

		dm.exToAdd = 0
		dm.potentialblue = 0
		dm.runBlueFlash = false // don't let the bar flash if it ain't full
		dm.exFlashTics = 0
		dm.latfreezecooloff = 0
		dm.justusednitro = 0
		dm.nitroCustomButton = 0
		dm.custom3DownTimer = 0
		dm.justEndedCrashCooldown = 0
		dm.gaugecheattimer = 0
		dm.bluePanel = false
		dm.acronotice = false
		dm.lastDriftLevel2 = 0
		dm.blueBoostFlag = false
		dm.transformBoost = false
		dm.notice = false
		dm.preDriftPoints = 0
		dm.nitroBoostType = 1

		setmetatable(dm, {
			__index = function(t, k) error("nope ".. k, 2) end,
			__newindex = function(t, k, v) error("nope "..k, 2) end,
		})

		p.driftmod = dm
    elseif leveltime <= 230 then
		--item stuff start
		dm.blueBoostFlag = false
		dm.transformBoost = false
		dm.nitroTimeBoosting = 0
		dm.nitroBoostCooldown = 0
		dm.meterFlashTics = 0
		dm.crashCooldown = 0
		dm.specialitemtype = 0
		dm.nitroItems = {0, 0, 0, 0} // 1 is normal, 2 is blue
		dm.transformTimer = {0, 0, 0, 0}
		dm.blueBlink = {0, 0, 0, 0}
		dm.blueBoosting = 0
		dm.runBlueFlash = false // don't let the bar flash if it ain't full
		dm.swapdir = 0
		dm.potentialblue = 0
		dm.hasThirdNitro = false
		--item stuff end

		dm.exBarFactor = 0
		dm.exPower = 0
		dm.exFlashTics = 0
		dm.pctSpeedMem = 0
		dm.crashAdd = 0
		dm.crashSub = 0
		dm.gaugeCheat = 0
		dm.specialDriftPoints = 0
		dm.blueAddDelay = 0
		dm.doRespawnPity = 0
		dm.respawnboost = 0
		dm.spinoutPity = false
		dm.blueBoost = false
		dm.blueDriftBoost = false
		dm.bluePanel = false
		dm.custom3DownTimer = 0
		dm.driftPoints = 0
		dm.previousDriftPoints = 0
		dm.preDriftPoints = 0
		dm.nitroBoostType = 1
	end

	if dm.justusednitro then dm.justusednitro = $ - 1 end

	if p.kartstuff[k_sneakertimer] then
		dm.nitroTimeBoosting = ($ + 1)
	else
		dm.nitroTimeBoosting = 0
	end

	if dm.nitroBoostCooldown then dm.nitroBoostCooldown = $ - 1 end

	if p.cmd.buttons & BT_ATTACK then
		dm.ntAtkDown = $ + 1
	else
		dm.ntAtkDown = 0
	end

	-- it's time...
	if p.spectator then return end
	
	-- If player somehow picks up an item, reset it
	
	if dm.nitroItems[1] ~= 0 then
		p.kartstuff[k_itemtype] = 17
		p.kartstuff[k_itemamount] = 1
		p.kartstuff[k_sadtimer] = 0
	else
		p.kartstuff[k_itemtype] = 0
		p.kartstuff[k_itemamount] = 0
	end

	// CRASH GAUGE GOES FIRST
	if leveltime > starttime then // only do this after the race starts
		// if you hit a wall, get your speed (by percent) and add that to your orange meter
		// this is based off of an actual kartrider mechanic for one of its karts:
		// "The Crash Gauge System activates past 200 km/h and gives the Rider an extra portion of boost gauge whenever they hit a wall
		// (it doesn't deploy when colliding with other Riders): the amount of boost obtained is proportional to the speed lost in the crash."

		// 1st gets a "reverse crash gauge" now, meaning they lose orange meter instead of gaining

		if dm.pctSpeedMem and (p.mo.eflags & MFE_JUSTBOUNCEDWALL) and not dm.crashCooldown then
			if (dm.justEndedCrashCooldown)
				dm.gaugeCheat = ($ + 1) // deteriorate a player's crash gauge power as punishment
				dm.gaugecheattimer = 12*TICRATE
			end
			local cheatval = max(0, dm.gaugeCheat-1)
			local cgFactor = max(0, (10 - cheatval*2 ))
			local cgFactor_1st = max(0, (35 + cheatval*2 )) -- reverse gauge gets STRONGER during gauge cheat

			if p.kartstuff[k_position] == 1 then -- let's hope nobody ends up in 0th
				dm.crashSub = ($ + (dm.pctSpeedMem*(cgFactor_1st)) )
			else
				dm.crashAdd = ($ + (dm.pctSpeedMem*(cgFactor)) )
			end

			dm.crashCooldown = 4*TICRATE // your "wall strats" will not work in this household
		end

		dm.pctSpeedMem = getKartPercent(p)

		if (dm.crashAdd)
			dm.driftPoints = ($ + max(1, (dm.crashAdd/8)) )
			dm.crashAdd = ($ - max(1, (dm.crashAdd/8)) )
		end

		if (dm.crashSub)
			dm.driftPoints = max(0, ($ - max(1, (dm.crashSub/8)) ))
			dm.crashSub = ($ - max(1, (dm.crashSub/8)) )
		end
	end

	if dm.blueBoosting then dm.blueBoosting = $ - 1 end

	if dm.meterFlashTics then
		dm.meterFlashTics = $ - 1
	end

	local yellowPower = (driftmodData.yelRate*10/(TICRATE*5))+((getKartPercent(p) > 10) and ((getKartPercent(p)*3)/40) or 0)

	-- if the player is behind, fill up their EX meter
	if p.kartstuff[k_position] ~= 1 and leveltime > starttime then
		if dm.exBarFactor + max(1, yellowPower) < driftmodData.exMeterSize then
			dm.exToAdd = max(1, yellowPower)
			dm.exFlashTics = TICRATE
		else
			dm.exToAdd = driftmodData.exMeterSize - dm.exBarFactor
			dm.exFlashTics = TICRATE
		end

		-- boostBonusEX
		if dm.pctSpeedMem and dm.pctSpeedMem >= 110 then
			if (dm.exBarFactor + max(1, (driftmodData.yelRate*10/4)/(TICRATE*5)) < driftmodData.exMeterSize)
				dm.exToAdd = max(1, (driftmodData.yelRate*10/4)/(TICRATE*5))
			else
				dm.exToAdd = (driftmodData.exMeterSize - dm.exBarFactor)
			end
		end
	else -- otherwise, drain it
		dm.exBarFactor = max(dm.exBarFactor - driftmodData.yelDecay, 0)
	end

	local exboostfactor = 131*dm.exBarFactor
	local exboostmax = (FRACUNIT*driftmodData.exBoostRate)/1000
	local noacro = not (cv_acro and cv_acro.value)

	// ex boosting
	local sneakerspeed = ((p.kartstuff[k_sneakertimer]) and K_GetSneakerSpeed() or 0)
	local sneakeraccel = ((p.kartstuff[k_sneakertimer]) and 8*FRACUNIT or 0)

	if noacro then // augment exists
		p.kartstuff[k_speedboost] = max($, min(exboostmax, ((exboostfactor*driftmodData.exBoostRate)/1000)) + sneakerspeed)
		p.kartstuff[k_accelboost] = max($, min(exboostmax, ((exboostfactor*driftmodData.exBoostRate)/1000)) + sneakeraccel)
	end

	if dm.respawnboost then
		local ticseven = 7*TICRATE

		-- original respawn boost was comically useless, let's try copying how driftboosts are
		local respboost = (max(3, ((FRACUNIT/3)/ticseven)))*dm.respawnboost
		local respaccel = (max(3, ((4*FRACUNIT)/ticseven)))*dm.respawnboost

		local rboostpower = ((exboostfactor and noacro) and ( ((exboostfactor*3)/10) + respboost) or ((FRACUNIT/8)+respboost))
		local raccelpower = ((exboostfactor and noacro) and ( ((exboostfactor*3)/10) + respaccel) or ((FRACUNIT/8)+respaccel))

		p.kartstuff[k_speedboost] = max($, rboostpower + sneakerspeed)
		p.kartstuff[k_accelboost] = max($, raccelpower + sneakeraccel)

		dm.respawnboost = $ - 1
	end

	if dm.exToAdd then
		local additive = max(1, dm.exToAdd/8)
		dm.exBarFactor = ($ + additive)
		dm.exToAdd = ($ - additive)
	end

	dm.hasThirdNitro = p.kartspeed < 3
	dm.hasFourthNitro = p.kartspeed < 2

	for i = 1, 4 do
		if dm.transformTimer[i] > 0 then
			if dm.transformTimer[i] == 1 then
				dm.blueBlink[i] = TICRATE/2
				S_StartSound(nil, sfx_itrolk, p)
				dm.nitroItems[i] = 2
			end
			dm.transformTimer[i] = $ - 1
		end

		if dm.blueBlink[i] > 0 then
			dm.blueBlink[i] = $ - 1
		end
	end

	if dm.blueAddDelay then dm.blueAddDelay = $ - 1 end

	// handle item swapping
	if p.cmd.buttons & (dm.nitroCustomButton or BT_CUSTOM3) then
		dm.custom3DownTimer = $ + 1
	else
		dm.custom3DownTimer = 0
	end

	if ((dm.custom3DownTimer > 0) and (dm.custom3DownTimer < 3) and (not dm.swapdir) and (dfn_findFullSlots(p) > -1))
		local swSnd = cv_swapsound.value and sfx_ntrsw or sfx_ntrsw2
		S_StartSound(nil, swSnd, p)
		dm.swapdir = 60
	end

	if (dm.swapdir)
		if (dm.swapdir+60 >= 180)
			local mem = dm.nitroItems[1]
			local tMem = dm.transformTimer[1]
			dm.nitroItems[1] = dm.nitroItems[2]
			dm.transformTimer[1] = dm.transformTimer[2]
			dm.transformTimer[2] = tMem
			dm.nitroItems[2] = mem
			dm.swapdir = 0
		else
			dm.swapdir = ($ + 60)
		end
	end

	if (p.playerstate ~= PST_DEAD) then
		local inGimmick = dMod_PlayerInCourseGimmick(p)
		local onGround = P_IsObjectOnGround(p.mo) or p.kartstuff[k_pogospring] or inGimmick

		// fucking double-use bug, ruining cool strats since April 2022
		local snkrUsed = dm.nitroItems[1] and (not dm.nitroBoostCooldown) and dm.ntAtkDown == 1 and onGround and not p.kartstuff[k_spinouttimer] // not when you're fucking spinning out

		local usingBlue = dm.nitroItems[1] == 2 or dm.transformTimer[1]
		
		if (dmodDebug) then
			if (onGround)
				p.mo.colorized = true
			else
				p.mo.colorized = false // will break stars, but I can't be assed to put in checks
			end
		end

		if (dm.crashCooldown)
			dm.crashCooldown = ($ - 1)

			if (dm.crashCooldown == 1) then dm.justEndedCrashCooldown = (6*TICRATE) end
		end

		if (dm.justEndedCrashCooldown)
			dm.justEndedCrashCooldown = ($ - 1)
		end

		if (dm.gaugecheattimer)
			dm.gaugecheattimer = ($ - 1)

			if (dm.gaugecheattimer == 1)
				dm.gaugeCheat = 0
			end
		end

		if (p.mo.ggz_frozen)
			dm.latfreezecooloff = 8 // frozen players get a tiny cooldown
		end

		if (dm.latfreezecooloff)
			dm.latfreezecooloff = ($ - 1)
		end

		if (dm.exFlashTics)
			dm.exFlashTics = ($ - 1)
		end

		if not cv_blueon.value then
			dm.specialDriftPoints = 0
		end
		if (not P_PlayerTouchingSectorSpecial(p,4,6))
			dm.bluePanel = false
		end

		if snkrUsed then
			K_DoSneaker(p)

			theWholeNineYards(p, usingBlue)
			
			if usingBlue then p.kartstuff[k_sneakertimer] = dm.potentialblue end
			if not dm.nitroBoostType then dm.nitroBoostType = 1 end
			
			dm.nitroTimeBoosting = 0

			if (dm.nitroItems[1] == 2) // the super-strong boost from a blue nitro
				S_StartSound(p.mo, sfx_s25f)
				dm.blueBoosting = 3
				dm.blueBoostFlag = true // flag for special boost sound
				dm.nitroBoostType = 2 // blue boost
			else
				if (not dm.transformBoost) then dm.blueBoostFlag = false end // no blue boost, no blue boost sound
				dm.nitroBoostType = 1 // red boost
			end

			if ((dm.blueBoostFlag))
				if (S_SoundPlaying(p.mo, sfx_cdfm01))
					S_StopSoundByID(p.mo, sfx_cdfm01)
					S_StartSound(p.mo, sfx_ntrble)
					dm.nitroBoostType = 2
					dm.blueBoostFlag = false
				end
			end

			// CONSUMPTION HANDLER GOES HERE
			consumeNitro(p, dm.transformBoost)
		end

		if (p.slipstreamcharge) // equivalent to kartrider's "speed lanes"
			local myPos = p.kartstuff[k_position]
			local pcount = getPlayercount()

			local divValue = max(1, (((pcount/2)+1)-myPos))

			if K_IsPlayerLosing(p) then divValue = 1 end

			dm.driftPoints = ($1 + (driftmodData.slipstreamRate/divValue)) // less useful bonuses for those far ahead
		end

		// pity bonus for bottom half

		local myKartSpeed = K_GetKartSpeed(p)
		local pityActivateSpeed = (myKartSpeed)
		local myPos = p.kartstuff[k_position]

		if ((myPos > 1) or dm.exBarFactor)
			if ((p.speed >= pityActivateSpeed))
				dm.exPower = max(300, (((dm.exBarFactor*100)/90)))
				dm.exFlashTics = (max(2, ((TICRATE/2)*2)) + 1) // even numbers, always
			end
		end

		if (dm.exPower)
			dm.exPower = ($ - (max(1, dm.exPower/4)) )
		end

		if (p.kartstuff[k_sneakertimer])
			if not dm.blueBoost then
				//if (dm.specialitemtype < 1) dm.specialBonusAmt = ($1 + 25000) end
				dm.blueBoost = true
			end
			local playerBoost = p.kartstuff[k_speedboost]
			if P_PlayerTouchingSectorSpecial(p,4,6) and not dm.bluePanel then
				dm.potentialblue = p.kartstuff[k_sneakertimer]
				dm.nitroTimeBoosting = 0
				dm.nitroBoostType = 1 // panel boost icon now goes unused
				dm.bluePanel = true
			end
		else
			dm.blueBoost = false
			if (not dm.blueAddDelay) then dm.nitroBoostType = 1 end
		end

		if (p.kartstuff[k_respawn])
			dm.doRespawnPity = 1
		else
			if (P_IsObjectOnGround(p.mo) and (dm.doRespawnPity))
				if (dm.specialitemtype < 1) dm.specialBonusAmt = ($1 + 12000) end
				dmod_giveRewardSneaker(p, true) // respawn pity nitros are blue now

				dm.respawnboost = 7*TICRATE

				dm.doRespawnPity = 0
			end
		end
		if (p.kartstuff[k_spinouttimer])
			if not dm.spinoutPity and cv_blueon.value then
				if (dm.specialitemtype < 1) then dm.specialBonusAmt = ($1 + 7000) end
				dm.crashAdd = ($ + 5000)
				dm.spinoutPity = true
			end
		else
			dm.spinoutPity = false
		end

		if p.kartstuff[k_driftboost] then
			local driftreward = ((dm.lastDriftLevel2) and ((dm.lastDriftLevel2 > 2) and 35000 or ((dm.lastDriftLevel2 > 1) and 25000 or 15000)) or 0 )

			if not dm.blueDriftBoost then
				dm.blueAddDelay = ($ + ((p.kartstuff[k_driftboost]) + (TICRATE % leveltime) ) )
				dm.specialBonusAmt = ($1 + driftreward)
				dm.lastDriftLevel2 = 0

				dm.blueDriftBoost = true
			end
		else
			dm.blueDriftBoost = false
		end

		if (p.kartstuff[k_drift])
			local dLevel = getDriftLevel(p)
			local dRate = K_GetKartDriftSparkValue(p)
			local boosting = p.kartstuff[k_sneakertimer]

			if (p.kartstuff[k_driftcharge] > (dRate/3))
				dm.lastDriftLevel = dLevel
				dm.lastDriftLevel2 = dLevel
				if ((P_IsObjectOnGround(p.mo)) or (p.kartstuff[k_pogospring]))
					// the boost bonus should also count the speed past 110% - Azur
					local speedBonus = ( ((dm.pctSpeedMem) and (dm.pctSpeedMem >= 110)) and true or false)

					local exPct = ( ((dm.meterFactor*dm.exBarFactor)*2) / 500)

					local inFirst = ((p.kartstuff[k_position] == 1) and true or false)

					if (getPlayercount() == 1)
						inFirst = true
					end

					local exAdd = ((dm.exBarFactor) and ((exPct*20/100) + (dm.exPower*5/100)) or 0)

					dm.driftPoints = ($ + ((dm.meterFactor) + (((dm.meterFactor) * boostInheritance[max(1, min(9, p.kartspeed))])/100) + ( (boosting or speedBonus) and (dm.boostExtFactor / ((inFirst) and 1 or 3) ) or 0)) + exAdd)
				end
			else
				if (dm.exPower)
					dm.driftPoints = ($ + (((dm.exPower*10)/100)) ) // nerf or nothin'
				end
			end
		elseif (p.kartstuff[k_aizdriftstrat] and (not p.kartstuff[k_drift])) // sliptide bonus
			if ((P_IsObjectOnGround(p.mo)) or (p.kartstuff[k_pogospring]))
				local tideFactor = (((dm.meterFactor/2)*(driftmodData.sliptideFactor))/100)
				dm.driftPoints = ($1 + (tideFactor))
			end
		elseif (dm.lastDriftLevel > 0)
			local bDiv = driftmodData.bonusDiv
			local pb = (getBonusValue(p)/bDiv)
			dm.driftPoints = ($1 + ((dm.lastDriftLevel)*200))
			if (cv_blueon.value and dm.lastDriftLevel > 1) or dmodDebug then
				dm.specialBonusAmt = ($1 + ( ((dm.lastDriftLevel)*200)))
			end
			p.kartstuff[k_driftboost] = $1 + (pb/4)
			dm.lastDriftLevel = 0
		else
			if (dm.exPower)
				dm.driftPoints = ($ + ((dm.exPower*10)/100) ) // nerf or nothin'
			end
		end


		if (not p.kartstuff[k_driftcharge]) -- redundancy, but for a reason (I think)
			dm.preDriftPoints = dm.driftPoints
		end

		dm.previousDriftPoints = $ + ((dm.preDriftPoints - $)/8) -- your drift points are your previous points

		if (leveltime > 230)
			-- runBonusFactorMetric
			local pPos = p.kartstuff[k_position]

			// reworking this system
			// pity rates should take care of the position stuff here, fuck distance

			// not enjoying any of the rates I'm making so I guess it's time to make this its own thing
			local driftFactor = (K_GetDriftFactor(p) * 3) / 2

			if (K_IsPlayerLosing(p)) // podium bonus factor
				dm.meterFactor = driftmodData.meterRate + ((driftmodData.meterRate*35)/100) + driftFactor
				dm.boostExtFactor = ((driftmodData.boostRate*152)/100) // 52+, need more control
			elseif (pPos != 1)
				dm.meterFactor = driftmodData.meterRate + ((driftmodData.meterRate*15)/100) + driftFactor
				dm.boostExtFactor = ((driftmodData.boostRate*152)/100) // 52+, need more control
			else
				dm.meterFactor = ((driftmodData.meterRate*102)/100) + driftFactor //first gets 1.2x, just so that the "raw" rate doesn't feel sluggish
				dm.boostExtFactor = ((driftmodData.boostRate*152)/100)-driftmodData.boostRate // 52+, need more control
			end

			if not dm.notice then
				chatprintf(p, infoSt1)
				chatprintf(p, infoSt2)
				dm.notice = true
			end

			if (not dm.acronotice)
				if ((cv_acro and cv_acro.value))
					chatprintf(p, "\x82".."Acrobatics are on! EX-boost has been turned off for balance.".."\x80")
				end
				dm.acronotice = true
			end
		else
			if ((not (cv_acro and cv_acro.value)) and dm.acronotice)
				dm.acronotice = false
			end
		end
	end

	// moving this ALL the way down here so that I can put in a "attempted to change skin" check
	if not dm.hasThirdNitro then
		dm.transformTimer[3] = 0
		dm.blueBlink[3] = 0
		dm.nitroItems[3] = 0 // third slot should have nothing if you switch to a 2-slot speed
	end

	if not dm.hasFourthNitro then
		dm.transformTimer[4] = 0
		dm.blueBlink[4] = 0
		dm.nitroItems[4] = 0 // third slot should have nothing if you switch to a 2-slot speed
	end

	-- NITRO GET!
	if dm.driftPoints >= 10000 or (dmodDebug and (p.cmd.buttons & BT_CUSTOM2)) then
		dm.meterFlashTics = METERFLASHTIME
		dmod_giveRewardSneaker(p)
		dm.crashAdd = 0 // reset this too, your wall strats will NOT work

		dm.driftPoints = 0
		dm.previousDriftPoints = 0
		dm.preDriftPoints = 0
	end

	local bluePointsToAdd = dm.specialDriftPoints+(dm.specialBonusAmt)

	if ((dm.specialDriftPoints < bluePointsToAdd) and (not dm.blueAddDelay))
		local addAmt = ((dm.specialBonusAmt/6 > 1) and (dm.specialBonusAmt/6) or 1)
		dm.specialDriftPoints = ($ + addAmt)
		dm.specialBonusAmt = ($ - addAmt)
	elseif (dm.specialDriftPoints > bluePointsToAdd)
		dm.specialBonusAmt = 0
		dm.specialDriftPoints = bluePointsToAdd
	end

	if ((dm.specialDriftPoints/100) >= (driftmodData.specialMtrSize/100))
		dm.specialDriftPoints = driftmodData.specialMtrSize // "value snapping"
	end

	if (dm.specialDriftPoints >= driftmodData.specialMtrSize)
		if (dm.nitroItems[1] == 0 and dm.nitroItems[2] == 0)
			dm.specialDriftPoints = driftmodData.specialMtrSize
		else
			dm.specialDriftPoints = 0
			local n1 = dm.nitroItems[1]
			local n2 = dm.nitroItems[2]
			local n3 = dm.nitroItems[3]
			local n4 = dm.nitroItems[4]

			if (n1 == 1)
				if (not dm.transformTimer[1])
					dm.transformTimer[1] = (TICRATE*3)/2
					if (n2 == 1) then dm.transformTimer[2] = ((TICRATE*3)/2) + (TICRATE/8) end
					if (n3 == 1) then dm.transformTimer[3] = ((TICRATE*3)/2) + (TICRATE/8) end
					if (n4 == 1) then dm.transformTimer[4] = ((TICRATE*3)/2) + (TICRATE/8) end

					//S_StartSound(nil, sfx_cdfm79, p)
				end
			elseif (n2 == 1)
				if (not dm.transformTimer[2])
					dm.transformTimer[2] = (TICRATE*3)/2

					if (n3 == 1) then dm.transformTimer[3] = ((TICRATE*3)/2) + (TICRATE/8) end
					if (n4 == 1) then dm.transformTimer[4] = ((TICRATE*3)/2) + (TICRATE/8) end
					//S_StartSound(nil, sfx_cdfm79, p)
				end
			elseif (n3 == 1)
				if (not dm.transformTimer[3])
					dm.transformTimer[3] = (TICRATE*3)/2
					if (n4 == 1) then dm.transformTimer[4] = ((TICRATE*3)/2) + (TICRATE/8) end
					//S_StartSound(nil, sfx_cdfm79, p)
				end
			elseif (n4 == 1)
				if (not dm.transformTimer[4])
					dm.transformTimer[4] = (TICRATE*3)/2
					//S_StartSound(nil, sfx_cdfm79, p)
				end
			end
		end
	end
end

addHook("MobjThinker", function(mo) // blue flames to signify blue meter bonus
	if driftmodData.isOn and cv_blueon.value then // not necessary if nitro ain't there
		local p = mo.target and mo.target.player
		if p then
			if p.driftmod.blueBoosting then
				mo.colorized = true
				mo.color = SKINCOLOR_BLUEBERRY
			else
				mo.colorized = false
			end
		end
	end
end, MT_BOOSTFLAME)

local checktypes = { "MT_RANDOMITEM", "MT_CDUFO", "MT_FLOATINGITEM", "MT_FLOATINGITEMSPAWNER", "MT_RANDOMITEMBOXSPAWNER", "MT_RANDOMITEMBOX", "MT_VL2ITEM_PANNEL" }
local removetypes = {}

addHook("ThinkFrame", do
	-- moving this here instead of using MobjThinker hooks
	-- makes it resilient to load order, and doesn't waste CPU time when driftmod isn't enabled
	-- ...is this overengineered? uhhh, yeah
	if driftmodData.isOn and leveltime > 4 and leveltime <= 230 then
		-- convert names to mobjtype
		for k, v in pairs(checktypes) do
			if pcall(do return _G[v] end) then
				--print("Hooked "..v)
				removetypes[_G[v]] = true
			end
			checktypes[k] = nil -- no need to check again... unless you load maps at runtime
		end

		local _, paneltype = pcall(do return _G["MT_VL2ITEM_PANNEL"] end)
		for mo in thinkers.iterate("mobj") do
			if removetypes[mo.type] then
				if mo.type == paneltype and mo.subsector and mo.subsector.sector then
					mo.subsector.sector.floorpic = "VL2ITEMB"
				end
				P_RemoveMobj(mo)
			end
		end
	end

	if driftmodData.isOn then
		for p in players.iterate do runDriftMod(p) end
	
		-- Yes, do it every frame because other mods keep enabling it back
		if not xItemLib then
			if roulettehud then roulettehud.hide = true end
			hud.disable("item")
		else
			for p in players.iterate do
				p.xItemData.enableHud = false
			end
		end
	elseif leveltime < 2 then -- conflicts with other scripts...
		if not xItemLib then
			if roulettehud then roulettehud.hide = false end
			hud.enable("item")
		else
			for p in players.iterate do
				p.xItemData.enableHud = true
			end
		end
	end
end)

-- this is sneaker trails now. cry about it
addHook("MobjThinker", function(mo)
	if driftmodData.isOn and mo.target then
		if not mo.colorized then mo.tics = 1 end
		mo.colorized = true
		mo.color = mo.target.player.skincolor
	end
end, MT_SNEAKERTRAIL)

if dmodDebug then print("Hooked") end

addHook("MapLoad", do
	driftmodData.isOn = false
	if cv_driftmod.value then
		driftmodData.isOn = true

		-- map the bloody custom
		for p in players.iterate do
			if p.specialBtMem and p.driftmod.nitroCustomButton ~= p.specialBtMem then
				CONS_Printf(p, "Your special item button is now Custom "..p.cusPref)
				p.driftmod.nitroCustomButton = p.specialBtMem
				p.cusDisplay = p.cusPref // for HUD text
			end
		end
	end
end)

-- HUD STUFF --

local driftmodmeter, driftmodmtrEX, preraceTrick, preraceEX
local preNoBlue, preNoBlueEX
local nitroMeterFlash, nitroFlash4P, fourPlayerMeter
local nobluemeter, nobluemtrEX, noblue4p
local exText, exText4P, stackIcon, smallStackIcon
local smallSlot, smallNitros, mutedNitro
local delayIcons, delayIcons4P
local slipText4P, bigSlot, bigNitros, buttonReminders, timerForP1

local function dfmod_draw4PDelayTimer(v, time, x, y, flags)
	local num = string.format("%d.%02d", time / TICRATE, ((time*100) / TICRATE) % 100)
	for i = 1, #num do
		local char = string.sub(num, i, i)
		local patch = v.cachePatch(char == "." and "PINGDOT" or "PINGN"..char)
		v.draw(x, y, patch, flags)
		x = $ + (patch.width - 1) * ((flags & V_NOSCALESTART) and v.dupx() or 1)
	end
end

local function dfmod_drawEXPercent(v, n, x, y, flags, colmap)
	local num = string.format("%d.%d%%", n / 10, (n % 10))
	for i = 1, #num do
		local char = string.sub(num, i, i)
		local patch = v.cachePatch(char == "." and "PINGDOT" or (char == "%" and "PINGPCT" or "PINGN"..char))
		v.draw(x, y, patch, flags, colmap)
		x = $ + (patch.width - 1)
	end
end

local BASEVIDWIDTH, BASEVIDHEIGHT = 320, 200

hud.add(function(v, p, cam)
	// ALWAYS cache the patches, stop desyncing FUCK -- desync???
	if not smallSlot then
		// cache patches for item slots and sneakers
		smallSlot = v.cachePatch("K_ISBG")
		bigSlot = v.cachePatch("K_ITBG")
		smallNitros = {v.cachePatch("K_ISNTRR"), v.cachePatch("K_ISNTRB")}
		mutedNitro = v.cachePatch("DTCLTM")
		bigNitros = {v.cachePatch("K_ITNTRR"), v.cachePatch("K_ITNTRB")}

		stackIcon = v.cachePatch("DCSTK")
		smallStackIcon = v.cachePatch("DSSTK")

		delayIcons = {v.cachePatch("DTRDTM"), v.cachePatch("DTBLTM"), v.cachePatch("DTPNTM")}
		delayIcons4P = {[0] = v.cachePatch("DSRDTM"), v.cachePatch("DSRDTM"), v.cachePatch("DSBLTM"), v.cachePatch("DSPNTM")}

		slipText4P = {v.cachePatch("D4SLS1"), v.cachePatch("D4SLS2"), v.cachePatch("D4SLS3"), v.cachePatch("D4SLS4"), v.cachePatch("D4SLS5")}

		// get the 4P meter
		fourPlayerMeter = {v.cachePatch("DMTR4P1"), v.cachePatch("DMTR4P2"), v.cachePatch("DMTR4P3"), v.cachePatch("DMTR4P4")}
		noblue4p = {v.cachePatch("DMNB4P1"), v.cachePatch("DMNB4P2"), v.cachePatch("DMNB4P3"), v.cachePatch("DMNB4P4")}

		nobluemeter = {v.cachePatch("DRNBLSD"), v.cachePatch("DRSPSTD"), v.cachePatch("DRNBLWD")}
		nobluemtrEX = {v.cachePatch("DRNBESD"), v.cachePatch("DRSPSTD"), v.cachePatch("DRNBEWD")}

		exText = {v.cachePatch("DEXBAR1"), v.cachePatch("DEXBAR2")}
		exText4P = {v.cachePatch("DEB4P1"), v.cachePatch("DEB4P2")}

		// get the main meter
		driftmodmeter = {v.cachePatch("DRMTRSD"), v.cachePatch("DRSPSTD"), v.cachePatch("DRMTRWD")}
		driftmodmtrEX = {v.cachePatch("DRMTESD"), v.cachePatch("DRSPSTD"), v.cachePatch("DRMTEWD")}

		// pre-race trickery because of dumbass bar opacity
		preraceTrick = {v.cachePatch("DRPRESD"), v.cachePatch("DRSPSTD"), v.cachePatch("DRPREWD")}
		preraceEX = {v.cachePatch("DEPRESD"), v.cachePatch("DRSPSTD"), v.cachePatch("DEPREWD")}

		preNoBlue = {v.cachePatch("DRPNBSD"), v.cachePatch("DRSPSTD"), v.cachePatch("DRPNBWD")}
		preNoBlueEX = {v.cachePatch("DEPNBSD"), v.cachePatch("DRSPSTD"), v.cachePatch("DEPNBWD")}

		// meter flashes
		nitroMeterFlash = {v.cachePatch("DRFILSD"), v.cachePatch("DRSPSTD"), v.cachePatch("DRFILWD")}
		nitroFlash4P = {v.cachePatch("DFIL4P1"), v.cachePatch("DFIL4P2")}

		// get button patches
		buttonReminders = {v.cachePatch("DCSBT1"), v.cachePatch("DCSBT2"), v.cachePatch("DCSBT3")}

		timerForP1 = v.cachePatch("DTMR1P")
	end
	
	if v.interpolate then v.interpolate(true) end

	local dm = p.driftmod
	if not (p.mo and dm and driftmodData.isOn) then return end

    local screenYSub = splitscreen < 2 and 28 or 16
	local bardiff = 55

    local scrwidth = v.width()/v.dupx()
    local winheight = v.height()/v.dupy()
    local windiff = (winheight - BASEVIDHEIGHT)/2
    local left = (scrwidth - BASEVIDWIDTH)/2
	local widemetric = scrwidth >= 400 and 6 or 0
	local scrcenterx = BASEVIDWIDTH/2

	if widemetric then bardiff = 56 end
	if splitscreen == 1 then bardiff = $ + 11 end

    local hudx = scrcenterx - bardiff
	local splitY = (winheight/2) - windiff
	local spltHudY = splitY - screenYSub
    local hudy = (winheight - windiff) - screenYSub

	local splitindex = cam.pnum - 1
	local onRightSide = splitscreen > 1 and (splitindex & 1) or 0
	local bottomSide = splitindex & 2

	local x, y = hudx, hudy -- I hope you know where these two are used because I sure as hell don't fucking know!

	if splitscreen == 1 and splitindex == 0 then
		y = spltHudY
	elseif splitscreen > 1 then
		x = onRightSide and scrwidth - 87 - left or 42 - left
		y = bottomSide and hudy - windiff or spltHudY
	end

	// color system
	local spColor = SKINCOLOR_SAPPHIRE
	local rbwSpColor = 1 + (leveltime % (MAXSKINSVANILLA - 1))

	local barwidth = 56
	local exwidth = 48

	local barx = 23
	local bary = 4
	local barsize = 6

	// set bar width for widescreen
	if widemetric then
		barwidth = 78
		exwidth = 70
	end

	/*driftmodmtrEX
	nobluemtrEX
	preraceEX
	preNoBlueEX*/

	local dfLevel = getDriftLevel(p)
	local whitebar = nitroMeterFlash[1+(widemetric/3)] -- IS BACK!!!
	local meterType = cv_exbonus.value and driftmodmtrEX[1+(widemetric/3)] or driftmodmeter[1+(widemetric/3)]
	local prestart = leveltime < starttime - 3*TICRATE
	if prestart then
		if cv_exbonus.value then
			meterType = ((cv_blueon.value) and preraceEX[1+(widemetric/3)] or preNoBlueEX[1+(widemetric/3)])
		else
			meterType = ((cv_blueon.value) and preraceTrick[1+(widemetric/3)] or preNoBlue[1+(widemetric/3)])
		end
	end

	local splitdfFactor = 2
	local meterSpark
	local outputColor
	if dfLevel > 0 then
		if (dmodsparkcolors[dfLevel] ~= "rainbow")
			outputColor = v.getColormap(TC_DEFAULT, dmodsparkcolors[dfLevel])
		else
			outputColor = v.getColormap(TC_DEFAULT, rbwSpColor)
		end
		splitdfFactor = 0
		if splitscreen < 2 then meterSpark = driftmodmeter[2] end
	else
		outputColor = v.getColormap(TC_DEFAULT, spColor)
	end

	-- 3P/4P adjustments
	if splitscreen > 1 then
		barwidth = 24
		barsize = 4
		bary = 5
		if onRightSide then
			meterType = fourPlayerMeter[2+splitdfFactor]
			whitebar = nitroFlash4P[2]
			if not cv_blueon.value then meterType = noblue4p[2+splitdfFactor] end
			barx = 16
		else
			meterType = fourPlayerMeter[1+splitdfFactor]
			whitebar = nitroFlash4P[1]
			if not cv_blueon.value then meterType = noblue4p[1+splitdfFactor] end
			barx = 15
		end
	end

	if not cv_blueon.value and not prestart then
		meterType = (cv_exbonus.value and nobluemtrEX[1+(widemetric/3)] or nobluemeter[1+(widemetric/3)])
	end

	-- spark color
	local bonusColor = 229
	local barColor = 229
	if dfLevel == 2 then
		bonusColor = 127
	elseif dfLevel > 2 then
		bonusColor = rbwSpColor
	end

	local vflags = V_HUDTRANS

	-- draw the base HUD
    v.draw(x, y, meterType, vflags, outputColor)
	if meterSpark then
		v.draw(x, y, meterSpark, vflags, outputColor)
	end

	local specialpoints = dm.specialDriftPoints
	local exPt = dfLevel > 1 and extraPoints[dfLevel] or 0
	local exPt2 = dfLevel > 0 and extraPoints[dfLevel] or 0

	-- draw the blue bar
	if cv_blueon.value then
		local dmSPMeter = driftmodData.specialMtrSize
		local bonusSpPoints = specialpoints and min(specialpoints + exPt, dmSPMeter)
		if splitscreen > 1 then
			local drawDfBonus4P = (bonusSpPoints * barwidth)/dmSPMeter
			local drawspecial4p = (specialpoints * barwidth)/dmSPMeter
			v.drawFill(x+barx, y+(bary+6), drawDfBonus4P, 1, vflags|bonusColor)
			v.drawFill(x+barx, y+(bary+6), drawspecial4p, 1, vflags|barColor)
			if specialpoints >= driftmodData.specialMtrSize and leveltime % 2 then
				v.drawFill(x+barx, y+(bary+6), drawspecial4p, 1, vflags|1)
			end
		else
			local drawDfBonus = (bonusSpPoints * (barwidth+2))/dmSPMeter
			local drawspecial = (specialpoints * (barwidth+2))/dmSPMeter
			v.drawFill(x+(barx-1), y+(bary+8), drawDfBonus, 3, vflags|bonusColor)
			v.drawFill(x+(barx-1), y+(bary+8), drawspecial, 3, vflags|barColor)
			if specialpoints >= driftmodData.specialMtrSize and leveltime % 2 then
				v.drawFill(x+(barx-1), y+(bary+8), drawspecial, 3, vflags|1)
			end
		end
	end

	local meterpoints = dm.driftPoints
	local meterprev = dm.previousDriftPoints
	if meterpoints >= 10000 then print("OH NO!") end
	local driftCheckAdd = ((p.kartstuff[k_driftcharge] and p.kartstuff[k_drift]) or dm.crashAdd) and driftmodData.meterRate*2 or 0
	local bonusDfPoints = min(meterpoints + (p.kartstuff[k_driftcharge] >= K_GetKartDriftSparkValue(p) and driftCheckAdd or 0) + exPt2, 10000)

	-- the meter itself
	-- in 1P/2P, drawfill the EMPTY part of the meter and reveal the HUD graphic underneath
	-- in 3P/4P, just fill the meter like usual
	if splitscreen < 2 then
		local drawdriftextra = ((bonusDfPoints - meterpoints) * barwidth)/10000
		local drawaddingdrift = (((meterpoints+driftCheckAdd) - meterprev) * barwidth)/10000

		-- how much of the bar is empty
		local empty = ((10000 - meterpoints)*barwidth)/10000
		local empty2 = ((10000 - meterprev)*barwidth)/10000

		if not prestart then
			if drawaddingdrift then
				v.drawFill(x+barx+(barwidth-empty-1), y+bary, empty+1, barsize, vflags|((leveltime % 7)/3 == 0 and 1 or 82))
			end
			
			-- We black bar to be more opaque but not too much opaque
			local trans = v.localTransFlag()>>V_ALPHASHIFT
			
			if trans ~= 10 then
				trans = max(trans/2, max(trans-3, 0))
			end
			
			trans = trans<<V_ALPHASHIFT

			-- the empty background
			v.drawFill(x+barx+(barwidth-empty), y+bary, empty, barsize/2, trans|31)
			v.drawFill(x+barx+(barwidth-empty), y+bary+(barsize/2), empty, barsize/2, trans|26)
			v.drawFill(x+barx+(barwidth-empty), y+bary+((barsize*2)/3), empty, barsize/4, trans|20)

			-- how much drifting is adding to the bar
			v.drawFill(x+barx+(barwidth-empty), y+bary, drawdriftextra, barsize, vflags|bonusColor)

			-- the flashing bar for the meter filling up
			local fillcolor = leveltime % 7 < 3 and 1 or 82
			v.drawFill(x+barx+(barwidth-empty2), y+bary, drawaddingdrift, barsize, vflags|fillcolor)
		end
	else
		local drawdriftextra = (bonusDfPoints*barwidth)/10000
		local drawaddingdrift = ((meterpoints+driftCheckAdd) * barwidth)/10000

		v.drawFill(x+barx, y+bary, drawdriftextra, barsize, vflags|bonusColor)

		v.drawFill(x+barx, y+bary, drawaddingdrift, barsize, vflags|82)

		if (leveltime % 6)/2 ~= 1 then
			v.drawFill(x+barx, y+bary, drawaddingdrift, barsize, vflags|1)
		end

		local drawpoints_4p = (meterprev*barwidth)/10000
		v.drawFill(x+barx, y+bary, drawpoints_4p, barsize, vflags|89)
	end

	// meter flash
	if dm.meterFlashTics then
		local whitetics = dm.meterFlashTics
		-- the bar is drawn without transparency, so no point in supporting HUD transparency here
		local hudtrans = 9 - v.localTransFlag() >> V_ALPHASHIFT
		local whitetrans = 9 - FixedMul(FixedDiv(whitetics, METERFLASHTIME), hudtrans)
		v.draw(x, y, whitebar, whitetrans << V_ALPHASHIFT, outputColor)
	end

	local ssStack = (p.mo.stackedsneakers or (booststack and booststack.running and booststack.stackedGradeSum(p.mo))) or 0
	local spStack = p.mo.stackedpanels or 0
	local stacks = ssStack + spStack

	local sliptimers = (p.mo.itemsneakertimer or 0) + (p.mo.panelsneakertimer or 0)
	local boostTimeTotal = stacks and (sliptimers + p.kartstuff[k_driftboost]) or p.kartstuff[k_sneakertimer]
    if booststack and booststack.running then boostTimeTotal = p.mo.stacktics end

	-- EX meter
	local expoints = dm.exBarFactor
	if cv_exbonus.value then
		local exTextFactor = (dm.exFlashTics % 2) ~= 0 and 2 or 1

		local exscoring = min(100, ((10000/driftmodData.exMeterSize)*expoints)/100)
		local exboostscore = (exscoring*driftmodData.exBoostRate)/100
		local exboostpower = exboostscore -- max is 30%

		if splitscreen < 2 then
			local drawnboostpower = getFloatString(min(driftmodData.exBoostRate, exboostpower)*10)
			local drawnEX = min(expoints, driftmodData.exMeterSize)
			local drawEXBonus = (drawnEX * 2 * exwidth) / (driftmodData.exMeterSize * 2)
			local EXColor = 113

			v.drawFill(x+(barx+4), y+(bary+12), drawEXBonus, 2, EXColor)
			v.draw(x+(barx-11), y+(bary+11), exText[exTextFactor], vflags, outputColor)
			v.drawString(x+(barx-11)+(widemetric and 87 or 65), y+(bary+14), drawnboostpower.."%", V_ALLOWLOWERCASE|vflags, "thin")
			v.drawString(x+(barx-11)+(widemetric and 86 or 64), y+(bary+13), (expoints >= driftmodData.exMeterSize and "\x82" or "")..drawnboostpower.."%", V_ALLOWLOWERCASE|vflags, "thin")
		else
			local exDisp = onRightSide and -38 or 24
			local dontOverlap = (boostTimeTotal and not cv_boosthud.value) and 12 or 0

			if exDisp < 0 then
				exDisp = $ - 4
				if expoints > 99 then
					exDisp = $ - 4
				end
			end

			local defaultColor = v.getColormap(TC_DEFAULT, SKINCOLOR_WHITE)
			local goldColor = v.getColormap(TC_RAINBOW, SKINCOLOR_GOLD)
			local drawn4pboost = min(driftmodData.exBoostRate, min(exboostpower,9999))

			v.draw(x+barx+exDisp, y+(bary+1)-dontOverlap, exText4P[exTextFactor], vflags, outputColor)
			dfmod_drawEXPercent(v, min(expoints,9999), x+barx+exDisp+14, y+(bary+2)-dontOverlap, vflags)
			dfmod_drawEXPercent(v, drawn4pboost, x+barx+exDisp+14, y+(bary+2)-dontOverlap-8, vflags, expoints < driftmodData.exMeterSize and defaultColor or goldColor)
		end
	end

	-- IIIIT'S ITEM BOX TIME
	local fx, fy = -9, -8
	local oldflags = vflags -- save old flags for other HUD stuff

	if splitscreen == 0 then
		fx, fy = (scrcenterx-40)+widemetric, y - 35
	elseif splitscreen == 1 then
		vflags = V_HUDTRANS|V_SNAPTOLEFT|(splitindex == 1 and V_SPLITSCREEN or V_SNAPTOTOP) // flip P2 to the bottom.
	else
		vflags = V_HUDTRANS | (bottomSide and V_SPLITSCREEN or V_SNAPTOTOP) -- flip P3/P4 to the bottom
		if not onRightSide then // If we are P1 or P3...
			vflags = $ | V_SNAPTOLEFT
		else // else, that means we're P2 or P4.
			fx = BASEVIDWIDTH - 63
			vflags = $ | V_SNAPTORIGHT
		end
	end

	-- a bunch of stuff for drawing
	local subOffset = 0
	local revealTime = starttime - TICRATE/2
	if leveltime > revealTime and dm.hasThirdNitro then
		subOffset = leveltime <= starttime and (leveltime - revealTime)*4/3 or 24
	end

	local reverseIt = (splitscreen == 0 or onRightSide) and 1 or -1
	local slot3Push = subOffset * -reverseIt
	local slot4Push = subOffset * (dm.hasFourthNitro and -reverseIt or 0)
	local slotwidth = 24
	local slotmid = slotwidth/2
	local sCos = getPixelCosine(slotmid, dm.swapdir*ANG1)*reverseIt
	local sSin = getPixelSine(slotmid, dm.swapdir*ANG1)*reverseIt
	local ext = (splitscreen == 1 and widemetric) and slotwidth or 0
	local primaryCol = v.getColormap(TC_RAINBOW, p.skincolor)

	-- button reminder
	if leveltime < TICRATE*13/2 then
		local hitNum = p.cusDisplay or 3

		if splitscreen == 0 then
			v.draw(fx + 60, fy - 1, v.cachePatch("DSWIC2"), vflags, primaryCol)
			v.draw(fx - 4, fy - 1, v.cachePatch("DSWIC1"), vflags, primaryCol)
			v.drawString(fx + 14, fy - 9, "\130Swap with", V_ALLOWLOWERCASE|vflags, "thin")
			v.drawString(fx + 16, fy + 2, "\130"..customPrompt[hitNum].."!", V_ALLOWLOWERCASE|vflags, "thin")
		else
			local myBtn = buttonReminders[hitNum]
			local dropShadow = v.getColormap(TC_BLINK, SKINCOLOR_JET)
			v.draw(fx + ext + 12, fy+37, v.cachePatch("DSWIC4"), vflags, primaryCol)
			v.draw(fx + ext + 31, fy+43, myBtn, vflags, dropShadow)
			v.draw(fx + ext + 30, fy+42, myBtn, vflags)
		end
	end

	-- 1P icons are centered                                        vvv damn jitter
	local centering = splitscreen == 0 and slot3Push/2 + (slot4Push + 1)/2 or 0
	-- change center of extension
	local extraslots = splitscreen == 0 and slotwidth or slotwidth*onRightSide

	-- items!
	local cooldown = dm.nitroBoostCooldown
	for i = 1, 4 do
		if v.interpolate then
			v.interpolate(i)
			v.interpLatch(true)
		end
	
		local itemx, itemy
		if i == 1 then
			itemx, itemy = fx + ext + slot3Push + slot4Push - centering, fy
		elseif i == 2 then
			itemx, itemy = fx + slotwidth + ext + slot3Push + slot4Push - centering, fy
		elseif i == 3 then
			itemx, itemy = fx + extraslots + ext + slot4Push - centering, fy
		elseif i == 4 then
			itemx, itemy = fx + extraslots + ext - centering, fy
		end

		-- draw the border
		if i == 1 then
			v.draw(itemx, itemy, smallSlot, vflags, reverseIt > 0 and primaryCol or nil)
			itemx, itemy = $ + slotmid - sCos, $ - sSin
		end
		if i == 2 then
			v.draw(itemx, itemy, smallSlot, vflags, reverseIt < 0 and primaryCol or nil)
			itemx, itemy = $ - slotmid + sCos, $ + sSin
		end
		if (i == 3 and dm.hasThirdNitro) or (i == 4 and dm.hasFourthNitro) then
			v.draw(itemx, itemy, smallSlot, vflags)
		end

		-- draw the nitro
		local cmap
		local patchType = v.cachePatch("K_TRNULL")
		if dm.blueBlink[i] % 2 then
			cmap = v.getColormap(TC_BLINK, rbwSpColor)
		elseif dm.transformTimer[i] % 2 then
			cmap = v.getColormap(TC_RAINBOW, spColor)
		end
		if dm.nitroItems[i] ~= 0 then
			patchType = (cooldown and not cmap) and mutedNitro or smallNitros[cmap and 2 or dm.nitroItems[i]]
		end
		v.draw(itemx, itemy, patchType, vflags, cmap)
	
		if v.interpolate then
			v.interpLatch(false)
		end
	end
	
	if v.interpolate then v.interpolate(true) end

	-- cooldown for 3P/4P, next to the items
	if cooldown and splitscreen > 1 then
		local delayText = (cooldown/TICRATE).."."..((((cooldown*100)/TICRATE) % 100) /10)
		local font = onRightSide and "thin-right" or "thin"

		v.drawString(fx + (onRightSide and 10 or 60) + 1 + slot3Push + slot4Push, fy+25, delayText, vflags, font) // "drop shadow"
		v.drawString(fx + (onRightSide and 10 or 60) + slot3Push + slot4Push, fy+24, delayText, vflags, font)
	end

	-- back to normal...
	vflags = oldflags

	-- boost timers
	if boostTimeTotal then
		if cv_boosthud.value then
			if not (p.exiting or (p.pflags & PF_TIMEOVER)) then
				local drawx, drawy = SG_GetScreenCoords(v, p, cam, p.mo, p.mo.height)
				if drawx then
					drawx, drawy = $>>FRACBITS, $>>FRACBITS

					local dup = v.dupx()
					local vflags = V_NOSCALESTART|V_HUDTRANS

					v.draw(drawx + dup*15, drawy - dup*10, delayIcons4P[dm.nitroBoostType], vflags)
					dfmod_draw4PDelayTimer(v, boostTimeTotal, drawx, drawy - dup*6, vflags)

					if stacks then
						v.draw(drawx + dup*15, drawy - dup*20, smallStackIcon, vflags)
						SG_DrawPaddedNum(v, drawx + dup*12, drawy - dup*16, stacks, 1, "PINGN", vflags)
					end
				end
			end
		elseif splitscreen < 2 then
			local dlytimer = string.format("%d.%02d", boostTimeTotal/TICRATE, ((boostTimeTotal*100)/TICRATE) % 100)
			local greenDist = widemetric and 83 or 61

			if stacks > 0 then
				local stackx = x+barx+greenDist+42

				v.draw(stackx, y+(bary-7), stackIcon, vflags)
				v.drawString(stackx+23, y+(bary+5), stacks, V_ALLOWLOWERCASE|vflags, "thin") // "drop shadow"
				v.drawString(stackx+22, y+(bary+4), stacks, V_ALLOWLOWERCASE|vflags, "thin")
			end

			v.draw(x+barx+greenDist, y+(bary-7), delayIcons[dm.nitroBoostType], vflags)

			v.drawString(x+barx+greenDist+23, y+(bary+5), dlytimer, V_ALLOWLOWERCASE|vflags, "thin") // "drop shadow"
			v.drawString(x+barx+greenDist+22, y+(bary+4), dlytimer, V_ALLOWLOWERCASE|vflags, "thin")
		else --if splitscreen > 1 then
			local xDisp = 25
			local xDisp2, stringDisp

			if not onRightSide then // If we are P1 or P3...
				xDisp = 25
				stringDisp = 37
				xDisp2 = xDisp + 28
			else // else, that means we're P2 or P4.
				xDisp = -41
				xDisp2 = -59
				stringDisp = -29
			end

			// do bary+4 for the timers!
			v.draw(x+barx+xDisp, y+(bary-3), delayIcons4P[dm.nitroBoostType], vflags)
			dfmod_draw4PDelayTimer(v, boostTimeTotal, x+barx+stringDisp, y+bary+2, vflags)

			if stacks then
				v.draw(x+barx+xDisp2, y+(bary-3), smallStackIcon, vflags)
				SG_DrawPaddedNum(v, x+barx+xDisp2+13, y+bary+2, stacks, 1, "PINGN", vflags)
			end
		end
	end

	-- slipstream text
	--[[
	if p.slipstreamcharge or (dmodDebug and leveltime > 230) then
		local slipLvl = dmodDebug and (leveltime*2)/TICRATE or p.slipstreamcharge
		local cv_chargetoboost = CV_FindVar("slipstream_chargetoboost")
		local slipMax = (cv_chargetoboost and not dmodDebug) and cv_chargetoboost.value or 3*TICRATE+TICRATE/2
		if splitscreen < 2 then
			local meterGap = cooldown and 1 or 0
			local cx = x + (widemetric and (not meterGap and 33 or 66) or (not meterGap and 26 or 55))
			local cy = splitscreen and 9 or 33

			if dmodDebug then
				local speedBonus = (dm.pctSpeedMem and dm.pctSpeedMem >= 110) and true or false
				local boosting  = p.kartstuff[k_sneakertimer]
				local speedResult = getFloatString(dm.meterFactor + (dm.meterFactor * boostInheritance[max(1, min(9, p.kartspeed))])/100 + ((boosting or speedBonus) and dm.boostExtFactor or 0))
				v.drawString(cx+1, y-(cy-1)-(meterGap*((splitscreen) and 13 or 10)), speedResult, vflags, "thin")
				v.drawString(cx, y-cy-(meterGap*((splitscreen) and 13 or 10)), speedResult, vflags, "thin")
			else
				local bonusText = "SLIPSTREAM"
				local factor = min(slipLvl / (slipMax / #bonusText), #bonusText)
				local myColor = factor >= 10 and SG_Color2Chat[rbwSpColor] or "\x80" // rainbows at max
				local bonusOutput = string.sub(bonusText, 1, min(#bonusText, factor+1))

				v.drawString(cx+1, y-(cy-1)-(meterGap*((splitscreen) and 13 or 10)), "\x82"..bonusOutput, vflags, "thin")
				v.drawString(cx, y-cy-(meterGap*((splitscreen) and 13 or 10)), myColor..bonusOutput, vflags, "thin")
			end
		else
			local splitMetric = widemetric and 48 or 81
			local factor = slipLvl/(slipMax/5)

			local myColor = v.getColormap(TC_DEFAULT, factor >= 5 and rbwSpColor or SKINCOLOR_WHITE)

			if factor >= 1 then -- vvvvv  extra pixel! kek!
				v.draw(x + 15 + onRightSide, y - 6, slipText4P[min(5, factor)], V_HUDTRANS, myColor)
			end
		end
	end
	--]]

	-- cooldown for 1P/2P
	if cooldown and splitscreen < 2 then
		local maxl = (TICRATE*3)/2
		local barlength = 26
		local fill = (cooldown*barlength)/maxl
		local length = min(barlength, fill)
		local height = 2
		local bx = x + 69 -- nice
		local by = y - 32

		if splitscreen == 1 then
			bx = x + (widemetric and 68 or 58)
			by = y - 11
		end

		v.draw(bx-47, by-1, timerForP1, vflags)
		// The left dark "AA" edge
		v.drawFill(bx+1, by+1, length == 2 and 2 or 1, height, 12|vflags)
		// The bar itself
		if length > 2 then
			v.drawFill(bx+length, by+1, 1, height, 12|vflags) // the right one
			if height == 2 then
				v.drawFill(bx+2, by+2, length-2, 1, 8|vflags) // the dulled underside
			end
			v.drawFill(bx+2, by+1, length-2, 1, 120|vflags) // the shine
		end
		local bartimer = string.format("%d.%02d", cooldown/TICRATE, ((cooldown*100)/TICRATE) % 100)
		v.draw(bx-46, y-(splitscreen and 20 or 44), delayIcons[dm.nitroBoostType], vflags)

		// draw the text over the item
		v.drawString(bx-20, y-(splitscreen and 13 or 34), bartimer, vflags, "thin") // "drop shadow"
		v.drawString(bx-21, y-(splitscreen and 14 or 35), bartimer, vflags, "thin")
	end
end)
