//FLOATLIB -- an excuse to make floats work in console :^)
rawset(_G, "floatToFrac", function(s, warn)
	local pointLoc = string.find(s, ".", 1, true) or -1
	local subbed = string.sub(s, pointLoc+1)
	local f2f = string.find(subbed, "0", 1, true) and 10 or 1

	if pointLoc == -1 then
		if tonumber(s) == nil then print("This is not a number!"); return 0 end
		
		return tonumber(s)*100
	end

	local fs1 = string.sub(s, 1, pointLoc-1)
	local fs2 = string.sub(s, pointLoc+1)
	local fallbackNum = nil
	local fs1l = string.len(fs1)
	local fs2l = string.len(fs2)
	local tenFactor = fs1l-1 > 0 and 10^(fs1l-1) or 1
	local f2factor = fs2l == 1 and f2f or 1

	local f2n = tonumber(fs2)
	local f2ex = 10^(fs2l-2)
	local isOne = fs1l == 1 and 1 or 0
	local f2ex2 = 10^(fs2l+isOne-3)

	if f2n == nil then
		print("This is not a number!")
		return 0
	end

	if f2ex2 == 0 then f2ex2 = 1 end

	if fs2l > 2 then
		if warn then print("\x82".."WARNING: ".."\x80".."Float is outside of a tenths value. Results may be inaccurate.") end 
		if fs1l > 2 then
			fallbackNum = (tonumber(fs1) * 10^(fs2l+1) + f2n*f2ex)/100
		else
			fallbackNum = ((tonumber(fs1) * 10^fs2l + f2n)/tenFactor)/f2ex2
		end
	end

	local fs1t = tonumber(fs1)*100
	local fs2t = tonumber(fs2)*f2factor
	return fallbackNum or fs1t+fs2t
end)
